; routines to get the filename and filedevice
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include flp1_engine_aid_mac
        include flp1_engine_struct_h
        include ram1_inc_keys_err
        include ram1_inc_keys_ext_thg
*
; get filename we are working one
; filename is max 32 chars long and that amount of space has to be available in the return string !!
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; return filename (string or substring (C-string))
; errors
; itnf  buffer id invalid
cod_FNAM xsub
        regsave d1/a1/a4/a5
        move.w  #f_name,d1      ; start of filename
        bra.s   start
*
; get filedevice we are working one
; filename is max 32 chars long and that amount of space has to be available in the return string !!
; parameters, same as FNAM
; errors
; itnf  buffer id invalid
cod_FDEV xsub
        regsave d1/a1/a4/a5
        move.w  #f_device,d1    ; start of filedevice
start
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_file(a4),a4   ; we only need fileid
        lea     0(a4,d1.w),a4   ; start of filename

        ; now return what they wanted to know
        move.w  p.ret-4(a5),d1
        move.w  (a4)+,d0        ; filename length
        move.l  p.ret(a5),a1    ; place to fill in return value
        btst    #thp..sst,d1    ; return substring ??
        bne.s   sstr
        move.w  d0,(a1)+        ; fill in len
sstr    tst.w   d0
        beq.s   strend
        subq.w  #1,d0           ; adjust to dbf
lp      move.b  (a4)+,(a1)+     ; copy 'another' char
        dbf     d0,lp
strend  btst    #thp..sst,d1    ; return substring ??
        beq.s   done
        clr.b   (a1)+           ; end of string marker
done    moveq   #0,d0           ; no error
codend
        subend
;
        end
